#! /bin/sh

# The directory to store logs.
LOGDIR=""

DIR=`dirname $0`
MAP="$1"
if [ -z $MAP ] ; then
  MAP=Kobe
fi
if [ ! -d $MAP ] ; then
  MAP="$DIR/../maps/$MAP"
fi

LOG="rescue.log"
if [ ! -z $2 ] ; then
  LOG="`date +%m%d-%H%M%S`-$2-`basename $MAP`.log"
fi
if [ ! -z $LOGDIR ] ; then
  LOG="$LOGDIR/$LOG"
fi

export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:$DIR/../program/librescue:$DIR/../program/civilian/lib

OPTIONS="-logname $LOG -shindopolydata $MAP/shindopolydata.dat -galpolydata $MAP/galpolydata.dat"

xterm -T gis -e "$DIR/0gis.sh $OPTIONS -mapdir $MAP/ -gisini $MAP/gisini.txt 2>&1 | tee gis.log" &
sleep 2
xterm -T kernel -e "$DIR/1kernel.sh $OPTIONS 2>&1 | tee kernel.log" &
sleep 2
#xterm -e ./kuwataviewer.sh -l 300 &
xterm -T viewer -e "$DIR/2viewer.sh 2>&1 | tee viewer.log" &
xterm -T misc -e "$DIR/3miscsimulator.sh $OPTIONS 2>&1 | tee misc.log" &
xterm -T traffic -e "$DIR/4morimototrafficsimulator.sh 2>&1 | tee traffic.log" &
xterm -T fire -e "$DIR/5firesimulator.sh $OPTIONS 2>&1 | tee fire.log" &
xterm -T blockades -e "$DIR/6blockadessimulator.sh $OPTIONS 2>&1 | tee blockades.log" &
xterm -T collapse -e "$DIR/7collapsesimulator.sh $OPTIONS 2>&1 | tee collapse.log" &
sleep 2

xterm -T civilian -e "$DIR/8civilian.sh 2>&1 | tee civilian.log" &

sleep 2

echo "Start your agents"
echo "Press enter to end simulation"

read
killall xterm