/*
 * Copyright (c) 2005, The Black Sheep, Department of Computer Science, The University of Auckland
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
 * Neither the name of The Black Sheep, The Department of Computer Science or The University of Auckland nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

 Contributors and list of changes:

 Cameron Skinner
   Converted original Robocup Rescue software into librescue
*/

// Config.h
//
/////////////////////////////////////////////////////////////////////////////

#ifndef RESCUE_CONFIG_H
#define RESCUE_CONFIG_H

#include <string>

typedef std::string string;

namespace Librescue {
  /////////////////////////////////////////////////////////////////////////
  // Config

  /** ե䥳ޥɥ饤ꤵѥ᥿ */
  class Config {
  protected:
#		define P(type_, name_, value_)   type_ m_##name_;
#		include "parameters.h"
#		undef P
		
  public:
	virtual ~Config();
	Config();
		
#		define P(type_, name_, value_)   type_ name_() const { return m_##name_; }
#		include "parameters.h"
#		undef P

	/**
	 * ե뤫ץѥƥɤ߹ࡣ
	 * @param	filename
	 *		եΥե̾
	 */
	bool readConfigFile(const char* filename);
		
	/**
	 * ץѥƥ򹹿롣
	 * @return
	 *		顼ȯ false˹줿 true
	 * @param	name
	 *		ץѥƥ̾
	 * @param	value
	 *		ץѥƥͤɽʸؤΥݥ󥿡
	 */
	bool setValue(const char* name, const char* value);
		
	//	Config(const Config& source);
	//	Config& operator= (const Config& rhs);
	//	bool operator== (const Config& rhs) const;
  };
	
  /////////////////////////////////////////////////////////////////////////
} // namespace Rescue

#endif
