/*
 * Copyright (c) 2005, The Black Sheep, Department of Computer Science, The University of Auckland
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
 * Neither the name of The Black Sheep, The Department of Computer Science or The University of Auckland nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

 Contributors and list of changes:

 Cameron Skinner
*/

#ifndef ERROR_H
#define ERROR_H

#include <iostream>
#include "common.h"
#include "input.h"

#define BUFFER_LENGTH 256

#define LOG_DEBUG(...) {snprintf(errorBuffer,BUFFER_LENGTH,__VA_ARGS__);logDebug(errorBuffer);}
#define LOG_WARNING(...) {snprintf(errorBuffer,BUFFER_LENGTH,__VA_ARGS__);logWarning(errorBuffer);}
#define LOG_ERROR(...) {snprintf(errorBuffer,BUFFER_LENGTH,__VA_ARGS__);logError(errorBuffer);}
#define LOG_INFO(...) {snprintf(errorBuffer,BUFFER_LENGTH,__VA_ARGS__);logInfo(errorBuffer);}

namespace Librescue {
  void logError(const char* error);
  void logWarning(const char* warning);
  void logDebug(const char* debug);
  void logInfo(const char* info);
  void dumpBytes(const char* bytes, int size);
  void dumpBytes(const Byte* bytes, int size);
  void dumpBytes(const Bytes& bytes);
  void dumpBytes(Input& input);

  extern char errorBuffer[];
}

#endif
